// SPDX-FileCopyrightText: 2021 Johannes Loher
//
// SPDX-License-Identifier: MIT

import { packageName } from '../config';
import registerHandlebarsPartials from '../handlebars-partials';
import logger from '../logger';
import { registerMixins } from '../mixins/index.js';
import registerSettings from '../setiings';

export default function registerForInitHook() {
  Hooks.on('init', onInit);
}

async function onInit() {
  logger.info(`Initializing ${packageName}`);

  registerMixins();
  registerSettings();
  await registerHandlebarsPartials();
}
